function [out]=addnoise(in,tip,param)

%
%       ADDNOISE      aduna zgomot de diverse tipuri peste imagine
%          [imgout]=ADDNOISE(imgin,tipzg,param);
%          *  IMGOUT este imaginea corupta de zgomot
%          *  IMGIN este imaginea de intrare, nezgomotoasa
%          *  TIPZG este tipul de zgomot, si poate fi 'gaussian','uniform' sau
%             'impulsiv'
%          *  PARAM este parametrul ce caracterizeaza zgomotul
%                 PARAM reprezinta dispersia daca TIPZG este 'gaussian' sau 'uniform'
%                 PARAM reprezinta procentul de pixeli afectati daca TIPZG este 'impulsiv'
%

if nargin < 3,
   help addnoise
   error('N-ati furnizat suficienti parametri');
end

%if ~ischar(tip)
   %help addnoise
   %error('TIPZG trebuie sa fie un string');
%end

if strcmp(tip,'gaussian')
   out=min(256,max(1,round(in+param(1)*randn(size(in)))));
elseif strcmp(tip,'uniform')
   out=min(256,max(1,round(in+2*sqrt(3)*param(1)*(rand(size(in))-0.5))));
elseif strcmp(tip,'impulsiv')
   if 1<param(1) & param(1) < 100,
      param(1)=param(1)/100;
   end
   poz=floor(rand(size(in))+param(1));
   zgomot=1+255*round(rand(size(in)));
   out=in.*(~poz)+zgomot.*poz;
else
   help addnoise
   error('Specificati corect tipul de zgomot');
end
