%BHAT Metoda Bhattacharya de determinare a pragurilor de segmentare
%
%[PRAG,Z,INTERVAL,PARAM]=BHAT(H,LIMIT)
% PRAG este vectorul pragurilor de segmentare
% Z este functia de decizie (derivata logaritmului histogramei)
% INTERVAL este vecorul de intervale pe care functia z este descrescatoare
% PARAM este vectorul de parametri statistici calculati pentru
% componentele mixturii ([medie dispersie]).
% H este histograma imaginii
% LIMIT este lungimea minima a unui interval de descrestere a functiei
% de decizie; are IMPLICIT valoarea 1
%
% Creata de C. Vertan la 10.03.1797
% Ultima modificare la   10.03.3021

function [prg,z,interval,param]=bhat(h,limit);

if (exist('limit')==0)
 limit=1;
end

no=max(size(h));
z=log(h(2:no)+eps)-log(h(1:no-1)+eps);

prg=[];
prg_start=[];
desc=0;
k=1;
count=0;
start=1;

for i=2:max(size(z))
  if (z(i)<z(i-1))
    if (desc==0)
      start=i-1;
    end
    desc=1;
    count=count+1;
  else
    if (desc==1)&(count>limit)
      prg(k)=i;
      prg_start(k)=start;
      k=k+1;
    end
    desc=0;
    count=0;
  end
end

if (desc==1)&(count>limit)
  prg(k)=i;
  prg_start(k)=start;
end

%for i=1:k
% xdata=prg_start(i):prg(i);
% ydata=z(prg_start(i):prg(i));
% poly=polyfit(xdata,ydata,1);
% param(i,:)=[poly(2)/abs(poly(1)) sqrt(1/abs(poly(1)))];
%end
interval=[prg_start' prg'];