function bmp8wr(x,map,filename);
%BMP8WR Scrie un fisier BMP (Microsoft Windows Bitmap)de 8 bpp.
%	BMPWRITE(x,map,'filename') scrie in fisierul BMP cu 8 bpp
%	planul indexat x, descris de tabela de culoare map
%       cu numele 'filename'.
%	Daca extensia fisierului nu se da, se ia implicit '.bmp'
%
%	Creat de C. Vertan la 20 iul. 1995
%	Ultima modificare la 21 iul. 1995

if (nargin~=3)
	help bmp8wr
	error('Necesita 3 argumente !');
end;

if (isstr(filename)~=1)
	help bmp3wr
	error('Al treilea argument trebuie sa fie sir !');
end;

if (isempty(findstr(filename,'.'))==1)
	filename=[filename,'.bmp'];
end;

fid=fopen(filename,'wb','l');
if (fid==-1)
	error(['Error opening ',filename,' for output.']);
end;

fwrite(fid,['B';'M'],'char');

[biHeight,biWidth]=size(x);
rest=4-rem(biWidth,4);
if (rest==4)
	rest=0;
end
bfSize=biHeight*(biWidth+rest)+54;
fwrite(fid,bfSize,'long');
bfReserved1=0;
fwrite(fid,bfReserved1,'short');
bfReserved2=0;
fwrite(fid,bfReserved2,'short');
bfOffBits=54;
fwrite(fid,bfOffBits,'long');
biSize=40;
fwrite(fid,biSize,'long');

fwrite(fid,biWidth,'long');
fwrite(fid,biHeight,'long');
biPlanes=1;
fwrite(fid,biPlanes,'short');
biBitCount=8;
fwrite(fid,biBitCount,'short');
biCompression=0;
fwrite(fid,biCompression,'long');
biSizeImage=0;
fwrite(fid,biSizeImage,'long');
biXPels=0;
fwrite(fid,biXPels,'long');
biYPels=0;
fwrite(fid,biYPels,'long');
biClrUsed=0;
fwrite(fid,biClrUsed,'long');
biClrImportant=0;
fwrite(fid,biClrImportant,'long');

[m,n]=size(map);
if (m~=256)
	map=[map;zeros(256-m,3)];
elseif (m>256)
 error('Colormap exceeds 256 colors! Only 8-bit BMP file output is supported.');
end;

map=[fliplr(map*255),zeros(256,1)]';
fwrite(fid,map(:),'uchar');


  x=rot90(x,-1)-1;
  temp=[x;zeros(rest,biHeight)];
  fwrite(fid,temp,'uchar');  
fclose(fid);

