%COMPAS Extractor de contur cu operator compas
%
% [CONT]=COMPAS(IN,MASK)
% CONT este imaginea de intensitate a tranzitiei remapata la intervalul 1-256
% IN este imaginea careia i se extrag contururile (256 nivele de gri)
% MASK este masca ce corespunde calcularii componentei orizontale a
% gradientului (celelalte masti corespund unor rotatii de 45 grade)
% Masca trebuie sa fie 3 x 3.
%
% Creata de C. Vertan la 21.03.1997
% Ultima modificare la   21.03.1998


function [cont]=compas(in,mask);

[h,w]=size(in);

H1=mask(:);
H2=rot90(mask,1);
H2=H2(:);
H3=rot90(mask,2);
H3=H3(:);
H4=rot90(mask,3);
H4=H4(:);
mask=[H1(2) H1(1) H1(4);H1(3) H1(5) H1(7);H1(6) H1(9) H1(8)];
H5=mask(:);
H6=rot90(mask,1);
H6=H6(:);
H7=rot90(mask,2);
H7=H7(:);
H8=rot90(mask,3);
H8=H8(:);
H=[H1';H2';H3';H4';H5';H6';H7';H8'];

cont=zeros(size(in));

for i=2:h-1
 for j=2:w-1
   t=in(i-1:i+1,j-1:j+1);
   cont(i,j)=max(abs(H*t(:)));
 end
end

cont=remap(cont);
