%COMPR_VQ codare si reconstructie prin cuantizare vectoriala
%
%OUT = COMPR_VQ(IN,TABEL)
%Imaginea originala IN este codata dupa tabelul
%de cuantizare TABEL (numarul de linii este numarul
%de blocuri de cuantizare, numarul de coloane este
%patratul dimensiunii unui bloc. Imaginea reconstruita
%dupa codare (fiind deci o aproximare a imaginii originale)
%este OUT.
%
% Creata de C. Vertan la 15.06.2001
% Ultima modificare C. Vertan	15.06.2001

function out=compr_vq(in,vq_table);

[h,w]=size(in);
[clase,dim]=size(vq_table);
bloc=fix(sqrt(dim));
count=1;

if (bloc*bloc~=dim)
   error('VQ table size mismatch');
end

for i=1:bloc:h-bloc+1
   for j=1:bloc:w-bloc+1
      temp=in(i:i+bloc-1,j:j+bloc-1);
      data(count,:)=temp(:)';
      count=count+1;
   end
end

for k=1:count-1
   dist=sum((ones(clase,1)*data(k,:)-vq_table).^2,2);
   [m,pos]=min(dist);
   data(k,:)=vq_table(pos,:);
end

out=in;
count=1;
for i=1:bloc:h-bloc+1
   for j=1:bloc:w-bloc+1
      out(i:i+bloc-1,j:j+bloc-1)=reshape(data(count,:),bloc,bloc);
      count=count+1;
   end
end
