%CUMTHRES Segmentare pe histograma cumulativa
%
% [T1,T2]=CUMTHRES(H,PROC,TYPE)
% T1 si T2 sunt pragurile corespunzatore de segmentare pentru separarea
% obiectelor, ce incadreaza cel mai bine valoare dorita
% H este histograma imaginii (normalizata sau nu)
% PROC este procentul din suprafata imaginii pe care il ocupa
% obiectele; daca PROC nu se specifica, se considera
% implicit valoarea 0.1 (10%)
% Daca TYPE=0 se considera ca obiectele de interes sunt intunecate
% Daca TYPE=1 se considera ca obiectele de interes sunt luminoase
%
% Creata de C. Vertan la 10.03.97
% Ultima modificare la   10.03.98

function [t1,t2]=cumthres(h,proc,type)

%if (exist(proc==0)|(proc==[]))
if (proc==0)
  proc=.1;
end
if(exist('type')==0)
 type=0;
end

H=cumsum(h);

if (type==0)
p=find(H<=proc);
t1=p(max(size(p)));
p=find(H>proc);
t2=p(1);
end

if (type==1)
p=find(H<=1-proc);
t1=p(max(size(p)));
p=find(H>1-proc);
t2=p(1);
end
