%D2LUM_SM   Filtrare de netezire LUM a unei imagini
%
%          OUT=D2LUM_SM(IN,K,N) filtreaza imaginea "IN" cu un filtru de ordine LUM
%          de netezire de rang "K" si o fereastra de dimensiune "N"x"N".
%          "OUT" este o imagine de aceleasi dimensiuni cu "IN". Imaginile sunt indexate,
%          cu valori ale indexului de culoare intre 0 si 256.
%          Daca "N" nu se specifica, se ia implicit 3."N" trebuie sa fie impar,
%	   fereastra se considera centrata.
%	   Daca "K" nu se specifica, se ia implicit 1. Rangul "K" trebuie sa fie cuprins
%          in gama [1, (N*N+1)/2].
%
%          Creata de C. Vertan la 21 nov. 1995
%          Ultima modificare la   21 nov. 1995 
function out=d2lum_sm(in,k,n)

if exist('in')==0
  help d2lum_sm
  error('Trebuie specificata imaginea de prelucrat')
end

if exist('k')==0
  k=1;
end

if exist('n')==0
  n=3;
end

if (rem(n,2)==0)
   help d2lum_sm
   error('Dimensiunea ferestrei trebuie sa fie un numar impar')
end

if (k>(n*n+1)/2)
   help d2lum_sm
   error('Rangul filtrului trebuie sa fie mai mic decit (N*N+1)/2')
end

[h,w]=size(in);

dev=fix(n/2);
a=zeros(dev,w+n-1);
b=zeros(h,dev);
work=[a;b in b;a];
clear a b

for i=1:h
  for j=1:w
   
   temp=work(i:i+n-1,j:j+n-1);
   orig=work(i+dev,j+dev);
   t=temp(:);
   tt=sort(t);
   if tt(k)>orig
     out(i,j)=tt(k);
   else
     if tt(n*n-k+1)<orig
       out(i,j)=tt(n*n-k+1);
     else
       out(i,j)=orig;
     end
   end
 
  end
end


