function degr = degrad(orig,h,sigma,indicator)

%  DEGRAD simuleaza degradarea unei imagini prin filtrare liniara cu
%  un nucleu de convolutie si adaugare de zgomot
%      IMG_DEGRAD = DEGRAD(IMG_ORIG,NUCLEU,DISPERSIE,INDICATOR) 
%      efectueaza convolutia imaginii IMG_ORIG cu nucleul NUCLEU
%      si aduna zgomot alb gaussian de medie 0 si dispersie 
%      DISPERSIE peste rezultat, returnand imaginea IMG_DEGRAD.
%      INDICATOR specifica dimensiunea imaginii rezultat:
%            - 'valid' returneaza numai partea valida a convolutiei;
%            - 'same' returneaza o imagine de dimensiuni egale cu 
%                     imaginea originala;
%            - 'full' returneaza imaginea completa in urma convolutiei 
%                     2D
%        

if nargin ~= 3 & nargin ~= 4,
   help degrad;
   error('Nu ati furnizat suficienti parametri de intrare');
end

if ~exist('indicator','var')
   indicator = 'full';
end

degr = conv2(orig,h,indicator);
degr = degr + sigma*randn(size(degr));