%DILATARE
% OUT = DILATARE(IN,SE,COUNT)
%
% Imaginea de iesire OUT este dilatarea imaginii de
% intrare IN dupa elementul structurant SE, iterata de
% COUNT ori (implicit COUNT=1). Elementul structurant SE
% este definit prin coordonatele punctelor sale, date in ordinea
% coordonata de linie, coordonata de coloana; SE este deci o 
% matrice cu doua coloane si un numar de linii egal cu numarul de
% puncte al elementului structurant.
% Functia se poate aplica pentru imagini cu nivele de gri sau binare.
% Pentru imaginile binare, valoarea punctelor de fundal este 1, valoare
% punctelor obiect este 256.
%
% Creata de C. Vertan la 29.06.2001
% Ultima modificare: C. Vertan 29.06.2001
function out=dilatare(in,se,max_count,L)

if (exist('max_count','var')==0)
   max_count=1;
end

if (exist('L','var')==0)
   L=256;
end

[h_se,w_se]=size(se);
mindev=abs(min(se));
maxdev=abs(max(se));
[h,w]=size(in);

for count=1:max_count
  in=[ones(mindev(1),mindev(2)+maxdev(2)+w);ones(h,mindev(2)) in ones(h,maxdev(2));...
      ones(maxdev(1),mindev(2)+maxdev(2)+w)];
  [hh,ww]=size(in);

  for i=1+mindev(1):mindev(1)+h
     for j=1+mindev(2):w+mindev(2)
        out(i-mindev(1),j-mindev(2))=max(in(se(:,1)+i+hh*(se(:,2)+j-1)));
     end
  end
  in=out;
end