%ETAJFILT Filtru median multietaj
%
% OUT=ETAJFILT(IN,DIM,TIP)
% OUT este imaginea filtrata (indexata, cu nivele de gri)
% IN este imaginea de prelucrat (indexata, cu nivele de gri)
% DIM este dimensiunea ferestrei de filtrare patrate, centrate;
% DIM trebuie sa fie impar si implicit DIM=3.
% TIP selecteaza tipul de filtru: max-median (TIP=1),
% min-median (TIP=2) sau median-median (TIP=3).
%
% Scrisa de C. Vertan la 13.04.2001
% Ultima modificare C. Vertan la 13.04.2001
function [out]=etajfilt(in,dim,tip)

if (exist('in','var')==0)
   error('Trebuie specificata imaginea de prelucrat !');
end

if (exist('dim','var')==0)
   dim=3;
end

dev=floor((dim-1)/2);
if ((dim-2*dev-1))
   error('Dimensiune ferestrei trebuie sa fie impara !');
end

if ((exist('tip','var')==0)|(tip>3))
   tip=1;
end

out=in;
[h,w]=size(in);
if (dev>max([h w]))
   error('Fereastra de filtrare nu trebuie sa fie mai mare ca imaginea !');
end

for i=dev+1:h-dev
   for j=dev+1:w-dev
      temp=in(i-dev:i+dev,j-dev:j+dev);
      a=diag(temp);
      b=diag(rot90(temp));
      c=temp(dev+1,:);
      d=temp(:,dev+1);
      t=[a b c' d];
      t=median(t);
      if (tip==1)
         out(i,j)=max(t);
      else
         if (tip==2)
            out(i,j)=min(t);
         else
            out(i,j)=median([t in(i,j)]);
         end
      end
   end
end