function [z,b]=fourdesc(a)

% FOURDESC = functia contur pentru extragerea descriptorilor Fourier
%
% [U,IMCONT] = fourdesc(IM)
%
%  IM este imaginea binara de intrare ce contine un unic obiect ai carui pixeli au valoarea 1. 
%         Fundalul are valoarea 0.
%  U este vectorul complex ce contine coordonatele punctelor de contur in ordinea parcurgerii acestuia. 
%         Numarul de elemente din U este egal cu numarul de puncte din contur
%  IMCONT este imaginea binara ce contine conturul
%  
%  Creata de Mihai Ciuc la 31.01.2001
%  Ultima modificare la 31.01.2001


[l,c]=size(a);

% EXTRAGERE DE CONTUR PRIN METODA GRADIENTULUI MORFOLOGIC
temp=a;
for i=2:l-1,
   for j=2:c-1,
      temp(i,j)=min(min(a(i-1:i+1,j-1:j+1)));
   end
end

a=a-temp;


% PARTEA DE THINNING
for i=2:l-1,
   for j=2:c-1,
      if a(i,j),
         if (a(i,j-1)&a(i-1,j)&(~a(i+1,j+1))) | (a(i-1,j)&a(i,j+1)&(~a(i+1,j-1))) |...
               (a(i,j+1)&a(i+1,j)&(~a(i-1,j-1))) | (a(i+1,j)&a(i,j-1)&(~a(i-1,j+1))),
            a(i,j)=0;
         end
       end
   end
end

%PARTEA DE PRUNING
for i=2:l-1,
   for j=2:c-1,
      if a(i,j),
         B=a(i-1:i+1,j-1:j+1);
         C=B([1 2 3 6 9 8 7 4]);
         if (sum(abs(conv(C,[-1 1]))) == 2)
            a(i,j)=0;
         end
       end
   end
end


b=a;

L=sum(a(:));

x=zeros(1,L);

test=0;
for i=1:l,
   if test==1,
      break;
   end
   for j=1:c,
      if a(i,j)==1,
         test=1;
         break;
      end
   end
end

z(1)=i+sqrt(-1)*j;
a(i,j)=0;
i=1;
while(1)
   c1=real(z(i));
   c2=imag(z(i));
   test=0;
   for k=-1:1,
      for l=-1:1,
         if a(c1+k,c2+l)==1,
            test=1;
            break;
         end
      end
      if test==1,
         break;
      end
   end
   if test==0
      break;
   end
   i=i+1;
   z(i)=c1+k+sqrt(-1)*(c2+l);
   a(c1+k,c2+l)=0;
end

      
      
      