%GAUSMIXT Genereaza o histograma ca mixtura de distributii Gaussiene
%
%[FCT]=GAUSMIXT(PARAMS,PROC,INTERVAL)
% FCT este histograma (functie de densitate de probabilitate) generata
% PARAMS este matricea de parametri caracteristici modurilor; fiecare
% linie a acestei contine media si dispersia cate unui mod.
% PROC este vectorul procentelor de mixare a modurilor (IMPLICIT mixtura
% este omogena - toate procentele sunt aceleasi)
% INTERVAL este un vector [JOS,SUS] ce descrie intervalul de valori pe
% care se calculeaza histograma generata (IMPLICIT este [0, 255]). Punctele
% de calcul a functie generate sunt valorile intregi din intervalul dat.
%
% Scrisa de C. Vertan la 15.02.1998
% Ultima modificare la 10.03.2001
function [fct]=gausmixt(params,p,ranger)

if (exist('params')==0)
 error('Trebuiesc specificati parametrii modurilor')
end
[no,w]=size(params);
if (w~=2)
 error('Parametrii modurilor nu sunt specificati corect')
end

if (exist('ranger')==0)
 ranger=[0 255];
end
x=ranger(1):ranger(2);

if (exist('p')==0)
 p=ones(1,no)/no;
end
%if (p==[])

if isempty(p)
   
   p=ones(1,no)/no;
end
p=p/sum(p);

mu=params(:,1);
sigma=params(:,2);

for i=1:no
%P(i,:)=(p(i)/(sigma(i)*sqrt(2*pi)))*exp(-((x-mu(i))/sigma(i)).^2);
P(i,:)=(p(i)/(sigma(i)*sqrt(2*pi)))*exp((-((x-mu(i))/sigma(i)).^2)/2);
end
fct=sum(P)/sum(sum(P));

