%GDECOMP - Descompunerea unei transformari geometrice in transformari
%          geometrice elementare
%
%[OUT] = GDECOMP(IN)
% OUT este vectorul linie continand: factorul de scalare orizontala,
% factorul de scalare verticala, unghiul de rotatie si factorul de
% inclinare verticala corespunzand realizarii transformarii definite
% de matricea de transformare 2x2 IN.
%
% Creata de: 			C. Vertan la 09.03.2001
% Ultima modificare:		C. Vertan la 09.03.2001


function [out]=gdecomp(in)

t1=in(2,1)*in(2,1)+in(2,2)*in(2,2);
t2=in(1,1)*in(2,2)-in(2,1)*in(1,2);
t3=in(1,1)*in(1,1)+in(1,2)*in(1,2);

out(1)=t2/sqrt(t1);
out(2)=sqrt(t1);
out(3)=180*atan2(-in(2,1),in(2,2))/pi;
out(4)=sqrt(t3/(out(1)*out(1))-1);