%GMATRIX - Matricea unei transformari geometrice a imaginilor
%
%[OUT] = GMATRIX(IN)
% OUT este matricea 2x2 a transformarii geometrice (fara translatii !!!)
% definita fie prin parametrii de scalare, rotatie si inclinare, fie
% prin puncte marker. Daca se dau parametrii transformarilor elementare,
% IN are o singura linie pe care sunt date: factorul de scalare orizontala,
% factorul de scalare verticala, unghiul de rotatie (in grade), factorul
% de inclinare verticala. Pentru a considera inclinarea orizontala, se
% considera o transpunere a imaginilor IN si OUT. Daca se dau puncte
% marker, atunci IN are patru linii si un numar de coloane egal cu numarul de
% puncte marker. Fiecare coloana contine coordonatele orizontala si verticala
% pentru cate un punct marker, inainte si dupa transformare.
%
% Creata de: 			C. Vertan la 09.03.2001
% Ultima modificare:		C. Vertan la 09.03.2001


function [out]=gmatrix(in);

[h,w]=size(in);
if (h==1)
   % se dau parametrii transformarilor elementare
   out=[in(1) 0;0 in(2)]*[1 in(4);0 1]*[cos(in(3)*pi/180) sin(in(3)*pi/180);-sin(in(3)*pi/180) cos(in(3)*pi/180)];
else
   %se dau puncte marker
   x=in(1:2,:);
   x_transf=in(3:4,:);
   out=x_transf/x;
end
