%GPERNA - Transformarea unei imagini prin efect de perna
%
%[OUT] = GPERNA(IN,SCALE_X,SCALE_Y)
% OUT este varianta transformata a imaginii originale IN,
% interpolarea este de tip cel mai apropiat vecin, prin
% pixel carry-over. Deformarea este cotrolata de procentele
% SCALE_X si SCALE_Y (valori implicite 0.5).
%
% Creata de: 			C. Vertan la 09.03.2001
% Ultima modificare:		C. Vertan la 09.03.2001


function [out]=gperna(in,alpha,betaa)

if (exist('alpha','var')~=1)
   alpha=0.5;
end
if (exist('betaa','var')~=1)
   betaa=0.5;
end

[h,w]=size(in);
out=255*ones(h,w);
ax=alpha*w/2;
ay=betaa*h/2;

for i=1:h
   for j=1:w
      ty=h/2+(i-h/2)*(1-(2*ay*sin(pi*j/w))/h);
      tx=w/2+(j-w/2)*(1-(2*ax*sin(pi*i/h))/w);
      out(round(ty+0.5),round(tx+0.5))=in(i,j);
   end
end
