%GRADIENT Extractor de contur prin metoda de gradient
%
% [CONT]=GRADIENT(IN,MASK)
% CONT este imaginea de intensitate a tranzitiei (modulul gradientului),
% remapata la intervalul 1-256
% IN este imaginea careia i se extrag contururile (256 nivele de gri)
% MASK este masca ce corespunde calcularii componentei orizontale a
% gradientului (componenta verticala se obtine cu o masca rotita cu 90 grade)
% Masca trebuie sa fie 3 x 3.
%
% Creata de C. Vertan la 21.03.1997
% Ultima modificare la   21.03.1998


function [cont]=gradient(in,mask);

[h,w]=size(in);
Hx=mask(:);
Hy=rot90(mask);
Hy=Hy(:);

cont=zeros(size(in));

for i=2:h-1
 for j=2:w-1
   t=in(i-1:i+1,j-1:j+1);
   cont(i,j)=abs(Hx'*t(:))+abs(Hy'*t(:));
 end
end

cont=remap(cont);
