%GRAYMAS  Calculeaza masurile de calitate pentru o imagine
%         cu nivele de gri
%
% [SNR,PSNR,MSE, MAE]=GRAYMAS(X,Y,W)
% X - imaginea originala
% Y - imaginea de masurat
% W - latimea marginii ce se decupeaza, in pixeli (IMPLICIT 0)
% SNR - Raportul semnal zgomot (dB)
% PSNR - Raportul semnal de varf zgomot (dB)
% MAE - Eroarea medie absoluta
%
% Scrisa de C. Vertan la 22.02.1997
% Ultima modificare la 22.06.2001

function [snr,psnr,mse,mae]=graymas(x,y,win)

if (exist('win')==0)
 win=0;
end
[h,w]=size(x);
x=x(1+win:h-win,1+win:w-win);
y=y(1+win:h-win,1+win:w-win);
[h,w]=size(x);
dif=abs(x-y);
s=sum(dif(:).^2);
mae=mean(dif(:));
sorig=sum(sum(x.^2));
snr=10*log10(sorig/s);
psnr=10*log10((h-1)*(w-1)*(max(max(x))^2)/s);
mse=s/((h-2*win)*(w-2*win));