%GROW_REG Creste o regiune uniforma in imagine
%
%[SIR,SIR_VAL]=GROW_REG(IMG,I,J,PRAG,NRMAX)
% SIR este indicele pixelilor ce formeaza regiunea (inclusiv samanta)
% SIR_VAl este sirul valorilor pixelilor din regiune
% IMG este imaginea de prelucrat
% I,J sunt coordonatele pixelului de start (samanta)
% PRAG este diferenta maxim adimisa intre orice punct al regiunii
% si samanta; IMPLICIT este 15.
% NRMAX este numarul maxim de pixeli ai regiunii; IMPLICIT este 200.
%
% Scrisa de M. Ciuc la 22.01.1998
% Ultima modificare C. Vertan 10.03.1998 

function [sir,sir_val]=grow_reg(img,i,j,prag,nrmax)

if (exist('prag')==0)
     prag=15;
end
if (isempty(prag))
    prag=15;
end
if (exist('nrmax')==0)
    nrmax=200;
end

[dimx,dimy]=size(img);

seed=img(i,j);
map=zeros(size(img));
map(i,j)=1;
sir=zeros(nrmax,2);
sir_val=zeros(nrmax,1);
sir(1,1)=i;
sir(1,2)=j;
ptr=2;
sir_val(1)=seed;
ptr1=1;

while (ptr1<ptr) & (ptr < nrmax), 


i=sir(ptr1,1);
j=sir(ptr1,2);
for m=-1:1,
  for n=-1:1,
     if i+m >=1 & i+m <= dimx & j+n >=1 & j+n <=dimy ,
       if ~map(i+m,j+n),
        %CONDITIA DE ACCEPT/REJECT
        %seed = valoarea pixelului central => img(i,j)
        if abs(img(i+m,j+n)-seed) <= prag,
	    sir(ptr,:)=[i+m,j+n];
	    sir_val(ptr)=img(i+m,j+n);
            map(i+m,j+n)=1;
	    ptr=ptr+1;
	end
       end
     end
  end
end     
ptr1=ptr1+1;
end

b=max(size(find(sir_val)));
sir=sir(1:b,:);
sir_val=sir_val(1:b);
