%GTRANSF - Transformarea geometrica a imaginilor
%
%[OUT] = GTRANSF(IN,A,SWITCH)
% OUT este varianta transformata a imaginii originale IN
% conform transformarii geometrice definite de matricea
% A (matrice patrata de dimensiune 2).
% Interpolarea este de tip "cel mai apropiat vecin" ; transformarea
% este de tip pixel filling pentru SWITCH=0 sau 
% pixel carry-over pentru SWITCH=1 (valoare implicita).
%
% Creata de: 			C. Vertan la 09.03.2001
% Ultima modificare:		C. Vertan la 09.03.2001

function [out]=gtransf(in,A,sw)

if (exist('sw')==0)
   sw=1;
end

[h,w]=size(in);
temp=A*[1 1 h h;1 w 1 w];
t1=floor(min(temp'));
t2=floor(max(temp'));
out=255*ones(t2(1)+1-t1(1),t2(2)+1-t1(2));
clear temp

if (sw==1)
   %pixel carry-over
   alpha=ones(1,w);
   beta=1:w;
   for i=1:h
      temp=floor(A*[i*alpha;beta])+[(1-t1(1))*alpha;(1-t1(2))*alpha];
      for j=1:w
         out(temp(1,j),temp(2,j))=in(i,j);
      end
   end
else
   %pixel filling
   alpha=ones(1,t2(2)+1-t1(2));
   for ii=1:t2(1)+1-t1(1)
      temp=floor(inv(A)*[(ii-1+t1(1))*alpha;(1:(t2(2)+1-t1(2)))-(1-t1(2))*alpha]);
      for jj=1:t2(2)+1-t1(2)
         if ((temp(1,jj)>=1)&(temp(1,jj)<=h)&(temp(2,jj)>=1)&(temp(2,jj)<=w))
            out(ii,jj)=in(temp(1,jj),temp(2,jj));
         end
      end
   end
end

      