%LUMFILT Filtru neliniar de domeniu LUM
%
% OUT=LUMFILT(IN,TIP,RANG,DIM)
% OUT este imaginea filtrata (indexata, cu nivele de gri)
% IN este imaginea de prelucrat (indexata, cu nivele de gri)
% RANG este rangul filtrului de domeniu, ce utilizeaza o fereastra
% patrata, centrata, de dimensiune DIM. DIM trebuie sa fie impar; in
% mod implicit se utilizeaza o fereastra de filtrare 3 x 3 (DIM=3) si
% un rang RANG=1. Rangul este mai mic decat (DIM*DIM+1)/2.
% Filtrarea este de netezire (TIP=1, implicit) sau de contrastare (TIP=2).
%
% Scrisa de C. Vertan la 13.04.2001
% Ultima modificare C. Vertan la 13.04.2001
function [out]=lumfilt(in,tip,rang,dim)
if (exist('in','var')==0)
   error('Trebuie specificata imaginea de prelucrat !');
end

if ((exist('tip','var')==0)|(tip>2))
   tip=1;
end

if (exist('dim','var')==0)
   dim=3;
end

dev=floor((dim-1)/2);
if ((dim-2*dev-1)~=0)
   error('Dimensiune ferestrei trebuie sa fie impara !');
end

if (exist('rang','var')==0)
   rang=1;
end

if (rang>(dim*dim+1)/2)
   error('Rangul statisticii de ordine nu corespunde dimensiunii ferestrei !');
end

out=in;
[h,w]=size(in);
if (dev>max([h w]))
   error('Fereastra de filtrare nu trebuie sa fie mai mare ca imaginea !');
end


for i=dev+1:h-dev
   for j=dev+1:w-dev

      temp=in(i-dev:i+dev,j-dev:j+dev);
      temp=sort(temp(:));
      if (tip==1)
  
         if (temp(rang)>in(i,j))
             out(i,j)=temp(rang);
         else
            if (temp(dim*dim-rang+1)<in(i,j))
               out(i,j)=temp(dim*dim-rang+1);
            end
         end
      else  
         medie=(temp(rang)+temp(dim*dim-rang+1))/2;
         if (((temp(rang)<in(i,j))&(in(i,j)<medie)))
            out(i,j)=temp(rang);
         else
            if ((temp(dim*dim-rang+1)>in(i,j))&(in(i,j)>medie))
               out(i,j)=temp(dim*dim-rang+1);
            end
         end      
      end        
   end
end
