%MAS_COOC  Parametri caracteristici din matricea de coocurenta
%
%OUT=MAS_COOC(IN)
%IN este matricea de coocurenta calculata cu functia COOC
%Vectorul de iesire  OUT contine urmatoarele caracteristici ale texturii:
%omogentatea, contrastul, entropia, corelatia, omogenitatea locala
%directivitatea si uniformitatea
%
%Creata de C. Vertan la 20.03.97
%Ultima modificare la   20.03.97
function out=mas_cooc(in)

[h,w]=size(in);
nc=sum(sum(in));

out(1)=sum(sum(in.^2))/(nc*nc);

for i=1:w
  p(i)=sum(diag(in,i))+sum(diag(in,-i));
end
i=0:(w-1);
out(2)=sum(p*(i.^2)')/(nc*(w-1)*(w-1));

out(5)=sum(p./(1+i.^2))/nc;

p=find(in~=0);
p=in(p);
out(3)=1-sum(sum(p.*log(p)))/(nc*log(nc));

p=sum(in');
mx=p*i';
sx=p*((i-mx).^2)';
p=sum(in);
my=p*i';
sy=p*((i-my).^2)';
out(4)=abs(sum(sum(((i-mx)'*(i-my)).*in)))/(nc*sqrt(sx*sy));

out(6)=trace(in)/nc;

out(7)=sum(diag(in).^2)/(nc*nc);
