%MAS_IZO  Parametri caracteristici din matricea izosegmentelor
%
%REZ=MAS_IZO(IN)
%IN este matricea izosegmentelor calculata cu functia IZOSEG.
%Vectorul de iesire OUT are urmatoarele componente:
%proportia plajelor scurte, proportia plajelor lungi, heterogenitatea
%nivelelor de gri, heterogenitatea lungimilor plajelor, procentajul
%plajelor
%
%Creata de C. Vertan la 20.03.97
%Ultima modificare la   20.03.97

function rez=masizo(in)

[h,w]=size(in);
niz=sum(sum(in));

lengths=1:w;
hist=in*lengths';
rez(5)=niz/sum(hist);

lengths2=lengths.^2;
lengths2_matrix=ones(h,1)*lengths2;

grays=1:h;
mean_gray=grays*hist/niz;

grays2=(grays-mean_gray).^2;
grays2_matrix=(grays2')*ones(1,w);

rez(1)=sum(sum(in./lengths2_matrix))/niz;
rez(2)=sum(sum(in.*lengths2_matrix))/niz;

pa=sum(in')/niz;
pb=sum(in)/niz;

rez(3)=sum(pa.^2);
rez(4)=sum(pb.^2);

rez(8)=sum(sum((in./grays2_matrix)))/niz; %lgre
rez(9)=sum(sum((in.*grays2_matrix)))/niz; %hgre

rez(10)=sum(sum((in.*lengths2_matrix).*grays2_matrix))/niz; %lrheg
rez(11)=sum(sum((in.*lengths2_matrix)./grays2_matrix))/niz; %lrleg
rez(12)=sum(sum((in.*grays2_matrix).*lengths2_matrix))/niz; %srheg
rez(13)=sum(sum((in./lengths2_matrix)./grays2_matrix))/niz; %srleg

p=find(pa==0);
pa(p)=ones(size(p));
ha=-sum(pa.*log(pa))/log(h);
p=find(pb==0);
pb(p)=ones(size(p));
hb=-sum(pb.*log(pb))/log(w);
rez(6)=ha;
rez(7)=hb;