%MFIREAD   Citeste un fisier in format MFI
%
%          X=MFIREAD(filename) deschide fisierul 'filename', presupus in
%          format MFI. Extensia .mfi este considerata implicit.
%
%          Creata la 28 mai 1995 de C. Vertan
%          Ultima modificare la 28 mai 1995

function [X]=mfiread(filename);

if (nargin~=1)
        help mfiread
	error('Trebuie dat numele fisierului !');
end;

if (isstr(filename)~=1)
        help mfiread
	error('Numele fisierului trebuie dat ca sir !');
end;

if (isempty(findstr(filename,'.'))==1)
	filename=[filename,'.mfi'];
end;

fid=fopen(filename,'rb','l');
if (fid==-1)
	error(['Eroare la deschiderea fisierului  ',filename]);
end;

bfType=fread(fid,2,'char');
setstr(bfType);
if (bfType~=['M';'F'])
	fclose(fid);
	error('Acesta nu este un fisier MFI !');
end;

biWidth=fread(fid,1,'ushort');
biHeight=fread(fid,1,'ushort');

biCompression=fread(fid,1,'uchar');
biReserved=fread(fid,1,'uchar');

% read in 8-bit image data

	X=fread(fid,[biHeight,biWidth],'uchar');
	X=X'+1;
				
fclose(fid);



