function mfiwrite(X, filename);
%MFIWRITE Scrie un fisier .MFI.
%	MFIWRITE(X,'filename') scrie un fisier .MFI cu numele 'filename'
%	ce contine imaginea indexata X.
%	Daca nu se precizeaza nici o extensie pentru fisier, se ia
%	'.mfi' implicit.
%
%	Creata  de C. Vertan la 6 iulie 1995
%       Ultima modificare 6 iulie 1995
if (nargin~=2)
	help mfiwrite
	error('Necesita doua argumente');
end;

if (isstr(filename)~=1)
	help mfiwrite
	error('Al doilea argument trebuie sa fie un sir');
end;

if (isempty(findstr(filename,'.'))==1)
	filename=[filename,'.mfi'];
end;

fid=fopen(filename,'wb','l');
if (fid==-1)
	error(['Eroare la deschiderea ',filename,' pentru scriere']);
end;

fwrite(fid,['M';'F'],'char');

[biHeight,biWidth]=size(X);
fwrite(fid,biHeight,'short');
fwrite(fid,biWidth,'short');
biReserved=0;
fwrite(fid,biReserved,'short');
biComp=0;
fwrite(fid,biComp,'short');


X=(X-1)';
fwrite(fid,X(:),'uchar');

fclose(fid);

