% MOMENTS   calculeaza momentele invariante la translatie, scalare si
%	    invariantii absoluti ai unei forme (sau camp aleator)
%
%[MOM,MOM_T,MOM_ST,FI]=MOMENTS(IN,N)
% MOM este matricea momentelor
% MOM_T este matricea momentelor invariante la translatie
% MOM_ST este matricea momentelor invariante la translatie si scalare
% aceste doua matrici sunt de dimensiune (n+1)
% FI este vectorul ce contine cei 6 invarianti absoluti ai formei
% N este ordinul pana la care se calculeaza momentele (IMPLICIT 3)
% IN este o imagine ce contine forma (punctele formei pot avea orice
% valoare, punctele ce nu apartin formei trebuie sa fie nule)
%
% Scrisa de C. Vertan la 12.10.1996
% Ultima modificare la 07.03.1998

function [mom,mom_t,mom_st,fi]=moments(in,n)

if (exist('n')==0)
  n=3;
end

[i,j,v]=find(in);
im=i-mean(i);
jm=j-mean(j);
aria=sum(v);

for p=0:n
 for q=0:n
   mom(p+1,q+1)=sum(v.*(i.^p).*(j.^q));
   mom_t(p+1,q+1)=sum(v.*(im.^p).*(jm.^q));
   mom_st(p+1,q+1)=sum(v.*(im.^p).*(jm.^q))/(aria^((p+q+2)/2));
 end
end

if (nargout==4)
fi(1)=mom_st(3,1)+mom_st(1,3);
fi(2)=(mom_st(3,1)-mom_st(1,3))^2+4*mom_st(2,2)^2;
fi(3)=(mom_st(4,1)-3*mom_st(2,3))^2+(mom_st(1,4)-3*mom_st(3,2))^2;
fi(4)=(mom_st(4,1)+mom_st(2,3))^2+(mom_st(1,4)+mom_st(3,2))^2;
fi(5)=(mom_st(4,1)-3*mom_st(2,3))*(mom_st(4,1)+mom_st(2,3))*((mom_st(4,1)+mom_st(2,3))^2-3*(mom_st(3,2)+mom_st(1,4))^2);
fi(5)=fi(5)+(mom_st(1,4)-3*mom_st(3,2))*(mom_st(1,4)+mom_st(3,2))*((mom_st(1,4)+mom_st(3,2))^2-3*(mom_st(2,3)+mom_st(4,1))^2);
fi(6)=(mom_st(3,1)-mom_st(1,3))*((mom_st(4,1)+mom_st(2,3))^2-(mom_st(3,2)+mom_st(1,4))^2);
fi(6)=fi(6)+4*mom_st(2,2)*(mom_st(4,1)+mom_st(2,3))*(mom_st(1,4)+mom_st(3,2));
end