%NAKAGAWA Verifica daca modurile unei distributii sunt bine separate
%
% [LISTA]=NAKAGAWA(H,PARAM)
% LISTA este un tabel in care sunt trecuti indicii perechilor de moduri
% ce nu satisfac una dintre conditiile de separatie si conditia ce nu este
% indeplinita
% H este distributia (mixtura de moduri)
% PARAM este matricea partametrilor statistici ai modurilor individuale
% fiecare linie a matricii este [media dispersia] pentru cate un mod
% ! Este necesar ca parametrii modurilor sa fie dati in ordine crescatoare
% a mediilor acestora.
%
% Scrisa de C. Vertan la 10.03.1998
% Ultima modificare la 10.03.2001 M. Zamfir

function [bad_list,dif,rap,rap2]=nakagawa(h,params)

if (exist('params')==0)
 error('Parametrii modurilor lipsesc')
end
[no,w]=size(params);
if (w~=2)
 error('Parametrii modurilor nu sunt specificati corect')
end
if (no==1)
 error('Problema nu are sens pentru un singur mod')
end
bad_list=['Rezultatele testarii:'];
for i=2:no
 dif=params(i,1)-params(i-1,1);
 rap=params(i,2)/params(i-1,2);
 rap2=min(h(params(i-1,1):params(i,1)))/min([h(params(i,1)) h(params(i-1,1))]);
 if (dif<=4)
   bad_list=[bad_list;num2str(i) ' ' num2str(i-1) ' medii prea apropiate'];
 end
 if (rap>10)|(rap<.1)
   bad_list=[bad_list;num2str(i) ' ' num2str(i-1) ' dispersii prea diferite'];
 end
 if (rap2>.8)
   bad_list=[bad_list;num2str(i) ' ' num2str(i-1) ' separatie neclara'];
end  
end
[nl nc]=size(bad_list);
if nl==1
   bad_list=['modurile sunt bine separate'];
end

