% QT codarea imaginilor cu arbori cuaternari
%
%[OUT,H] = QT(IN,T,MIN,MAX)
%Functia QT realizeaza codarea imaginii originale IN (cu nivele
%de gri dupa un arbore cuaternar, imaginea reconstruita prin
%inlocuirea blocurilor "uniforme" de codare cu valoarea lor medie
%fiind returnata in matricea OUT. Vectorul H este histograma
%dimensiunii blocurilor de codare utilizata, corespunzand numarului
%de blocuri de codare utilizate de dimeniune 1, 2, 4 ... pana la
%dimensiunea maxima permisa MAX (putere de 2, valoare implicita 128).
%Dimensiunea minima a blocurilor de codare folosite este MIN
%(putere a lui 2, valoare implicita 2). Uniformitatea blocurilor este
%stabilita prin compararea diferentei maxime a valorilor pixelilor
%din blocul candidat din imaginea initiala cu pragul T (valoare
%implicita 20).
%
% Creata de C. Vertan la 18.07.2001
% Ultima modificare C. Vertan la 18.07.2001

function [out,h]=qt(in,thresh,mindim,maxdim,L)

if (exist('L','var')==0)
   L=256;
end
if (exist('maxdim','var')==0)
   maxdim=128;
end
if (exist('mindim','var')==0)
   mindim=2;
end
if (exist('thresh','var')==0)
   thresh=20;
end
thresh=thresh/(L-1);

s=qtdecomp((in-1)/(L-1),thresh,[mindim maxdim]);
[r,c,d]=find(s);
blocks=length(r);
for i=1:blocks
   temp=in(r(i):r(i)+d(i)-1,c(i):c(i)+d(i)-1);
   out(r(i):r(i)+d(i)-1,c(i):c(i)+d(i)-1)=mean(temp(:))*ones(d(i));
end

i=0:log(maxdim)/log(2);
pos=2.^i;
h=hist(d,pos);