%RANKFILT Filtru neliniar de ordine
%
% OUT=RANKFILT(IN,RANG,DIM)
% OUT este imaginea filtrata (indexata, cu nivele de gri)
% IN este imaginea de prelucrat (indexata, cu nivele de gri)
% RANG este rangul statisticii de ordine de la iesirea filtrului,
% calculata intr-o fereastra patrata, centrata, de dimensiune DIM.
% DIM trebuie sa fie impar. In mod implicit se calculeaza statistica
% mediana pentru o fereastra de filtrare 3 x 3 (DIM=3, RANG=5).
%
% Scrisa de C. Vertan la 13.04.2001
% Ultima modificare C. Vertan la 13.04.2001
function [out]=rankfilt(in,rang,dim)

if (exist('in','var')==0)
   error('Trebuie specificata imaginea de prelucrat !');
end

if (exist('dim','var')==0)
   dim=3;
end

dev=floor((dim-1)/2);
if ((dim-2*dev-1)~=0)
   error('Dimensiune ferestrei trebuie sa fie impara !');
end

if (exist('rang','var')==0)
   rang=5;
end

if (rang>dim*dim)
   error('Rangul statisticii de ordine nu corespunde dimensiunii ferestrei !');
end

out=in;
[h,w]=size(in);
if (dev>max([h w]))
   error('Fereastra de filtrare nu trebuie sa fie mai mare ca imaginea !');
end

for i=dev+1:h-dev
   for j=dev+1:w-dev
      temp=in(i-dev:i+dev,j-dev:j+dev);
      temp=sort(temp(:));
      out(i,j)=temp(rang);
   end
end
