%REMAP Scaleaza valorile unei matrici
%
%OUT=REMAP(IN,LO,HI)
% OUT este matricea rezultat ale carei valori sunt numere
% intregi din intervalul [LO,HI]. Implicit, LO este 1 si
% HI este 256 (corespund afisarii Matlab a imaginilor cu 256
% nivele de gri).
% IN este matricea de intrare.
% Daca matricea de intrare are toate valorile egale, matricea
% de iesire va avea toate valorile egale cu mijlocul intervalului
% de scalare, deci (HI+LO)/2.
%
% Scrisa de C. Vertan la 15.05.1995
% Ultima modificare la 10.03.1998
function [X]=remap(IN,lo,hi)

if (exist('IN','var')==0)
	help remap
	error('Input data missing !')
end

if (exist('lo','var')==0)
	lo=1;
end
if (exist('hi','var')==0)
	hi=256;
end


m=min(min(IN));
M=max(max(IN));
if (M~=m)
	a=(hi-lo)/(M-m);
	b=lo-a*m;
	X=fix(a*IN+b);
else
	X=((hi+lo)/2)*ones(size(X));
end